#include <mpi.h>
#include <math.h>

double norm (int n_i, double* x)
{
  double l_sum=0., g_sum;
  int i;

  for (i=1; i<=n_i; i++)
    l_sum += x[i]*x[i];

  MPI_Allreduce (&l_sum,&g_sum,1,MPI_DOUBLE,
                 MPI_SUM,MPI_COMM_WORLD);

  return sqrt(g_sum);
}
